<?php
class ApiController extends Zend_Controller_Action {

    public function init()  {
        $this->_helper->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
    }
    
    private function checkToken($data) {
        $db = new Application_Model_ApiHelper();
        if(!$db->validateToken($data)) {
            return false;
        } else {
            return true;
        }
    }
    
    public function loginAction() {
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $user = trim($request->user);
        $pass = trim($request->pass);
        
        $db = new Application_Model_ApiHelper();
        
        $arr = array();
        if($user=='' || $pass=='') {
            $arr['code'] = -1;
            $arr['msg'] = 'Username and/or Password cannot be empty.';
        } else {
            $info = $db->authenticate($user, $pass);
            if($info['code']==1) { //Authenticated
                $arr['code'] = 1;
                $arr['msg'] = '';
                $arr['profile'] = $info['profile'];
                $arr['token'] = $info['profile']['user_token'];
            } else {
                $arr['code'] = $info['code'];
                $arr['msg'] = $info['msg'];
            }
        }
        echo json_encode($arr);
    }
    
    public function logoutAction() {
        $db = new Application_Model_ApiHelper();
        
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $data = array();
        $data['userID'] = $request['user_id'];
        $data['token'] = $request['auth_token'];
        
        $arr = array();
        if($this->checkToken($data)) {
            $db->logout($data);
            $arr['code'] = 1;
            $arr['msg'] = 'You have been logged out successfully.';
        } else {
            $arr['code'] = -1;
            $arr['msg'] = 'There may be some technical issues. Please try again.';
        }
        return json_encode($arr);
    }
    
    public function forgotpasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $user = trim($request->user);
        echo json_encode($db->forgotPassword());
    }
    
    public function resetpasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $token = trim($request->token);
        $pass = trim($request->password);
        echo json_encode($db->resetPassword($token, $pass));
    }
    
    public function changepasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        
        $data = array();
        $data['oldPass'] = trim($request->oldPass);
        $data['newPass'] = trim($request->newPass);
        $data['token'] = trim($request->auth_token);
        $data['userID'] = trim($request->user_id);
        
        $arr = array();
        if(!$this->checkToken($data)) {
            $arr['code'] = -1;
            $arr['msg'] = 'Invalid Token.';
        } else {
            $db->changePassword($data);
            $arr['code'] = 1;
            $arr['msg'] = 'Password changed successfully.';
        }
        return json_encode($arr);
    }
    
    public function updateprofileAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        
        $response = $db->updateProfile($request);
        echo json_encode($response);
    }
}