<?php
class ApiController extends Zend_Controller_Action {

    public function init()  {
		header('Access-Control-Allow-Origin: *');  
		header('Access-Control-Allow-Headers: *');
        $this->_helper->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
    }
    
    private function checkToken($data) {
        $db = new Application_Model_ApiHelper();
        if(!$db->validateToken($data)) {
            return false;
        } else {
            return true;
        }
    }
    
    public function loginAction() {
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $user = trim($request->user);
        $pass = trim($request->pass);
        $db = new Application_Model_ApiHelper();
        $arr = array();
        if($user=='' || $pass=='') {
            $arr['code'] = -1;
            $arr['msg'] = 'Username and/or Password cannot be empty.';
        } else {
            $info = $db->authenticate($user, $pass);
            if($info['code']==1) { //Authenticated
                $arr['code'] = 1;
                $arr['msg'] = '';
                $arr['profile'] = $info['profile'];
                $arr['token'] = $info['token'];
            } else {
                $arr['code'] = $info['code'];
                $arr['msg'] = $info['msg'];
            }
        }
        echo json_encode($arr);
    }
    
    public function logoutAction() {
        $db = new Application_Model_ApiHelper();
        
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $data = array();
        $data['userID'] = $request['user_id'];
        $data['token'] = $request['auth_token'];
        
        $arr = array();
        if($this->checkToken($data)) {
            $db->logout($data);
            $arr['code'] = 1;
            $arr['msg'] = 'You have been logged out successfully.';
        } else {
            $arr['code'] = -1;
            $arr['msg'] = 'There may be some technical issues. Please try again.';
        }
        return json_encode($arr);
    }
    
    public function forgotpasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $user = trim($request->user);
        echo json_encode($db->forgotPassword());
    }
    
    public function resetpasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $token = trim($request->token);
        $pass = trim($request->password);
        echo json_encode($db->resetPassword($token, $pass));
    }
    
    /* public function changepasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        
        $data = array();
        $data['oldPass'] = trim($request->oldPass);
        $data['newPass'] = trim($request->newPass);
        $data['token'] = trim($request->auth_token);
        $data['userID'] = trim($request->user_id);
        
        $arr = array();
        if(!$this->checkToken($data)) {
            $arr['code'] = -1;
            $arr['msg'] = 'Invalid Token.';
        } else {
            $db->changePassword($data);
            $arr['code'] = 1;
            $arr['msg'] = 'Password changed successfully.';
        }
        return json_encode($arr);
    } */
    
	public function fetchtasksAction() {		
		$arrEvents = array();
		$event = array("title"=>"Event 1", "start"=>"2022-04-08", "end"=>"2022-04-08");
		array_push($arrEvents,$event);
		$event = array("title"=>"Event 2", "start"=>"2022-04-09", "end"=>"2022-04-09");
		array_push($arrEvents,$event);
		$event = array("title"=>"Event 3", "start"=>"2022-04-10", "end"=>"2022-04-11");
		array_push($arrEvents,$event);
		echo json_encode($arrEvents);
	}
	
	public function fetchcalendartasksAction() {		
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		if(!$request->dtFrom) {
			//$dtfrom = date('Y-m-d');
			if($request->iscal) {
			    $dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' -60 days'));
			} else {
			    $dtfrom = date('Y-m-d');
			}
			$dtfrom = $dtfrom.' 00:00:00';
		} else {
			$dtfrom = $request->dtFrom;
			$dtfrom = $dtfrom.' 00:00:00';			
		}
		
		if(!$request->dtTo) {
			$dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' +15 days'));
			$dtto = $dtto.' 00:00:00';
		} else {
			$dtto = $request->dtTo;
			$dtto = $dtto.' 23:59:59';
		}
        //$dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' +15 days'));
		//$dtto = $dtto.' 23:59:59';
		$tech_id = trim($request->user_id);
		//$tech_id = 10;
		$arr = array();
		$result = $db->fetchJobsForCalendar($dtfrom, $dtto, $tech_id);
		echo json_encode($result);
	}
	
    public function updateprofileAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        
        $info = $db->updateProfile($request);
		$arr = array();
		$arr['code'] = 1;
		$arr['msg'] = '';
		$arr['profile'] = $info['profile'];
        echo json_encode($arr);
    }
	
    public function changepasswordAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
        $info = $db->changePassword($request);
        echo json_encode($info);
    }
	
    public function tasksfordaterangeAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		if(!$request->dtFrom) {
			//$dtfrom = date('Y-m-d');
			if($request->iscal) {
			    $dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' -60 days'));
			} else {
			    $dtfrom = date('Y-m-d');
			}
			$dtfrom = $dtfrom.' 00:00:00';
		} else {
			$dtfrom = $request->dtFrom;
			$dtfrom = $dtfrom.' 00:00:00';			
		}
		
		if(!$request->dtTo) {
			$dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' +15 days'));
			$dtto = $dtto.' 00:00:00';
		} else {
			$dtto = $request->dtTo;
			$dtto = $dtto.' 23:59:59';
		}
        //$dtto = date('Y-m-d',strtotime(date('Y-m-d'). ' +15 days'));
		//$dtto = $dtto.' 23:59:59';
		$tech_id = trim($request->user_id);
		//$tech_id = 10;
		$arr = array();
		$result = $db->todaysJobs($dtfrom, $dtto, $tech_id);
		$arr['code'] = $result['code'];
		$arr['data'] = $result['data'];
        echo json_encode($arr);
    }
	
	public function taskdetailsAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		$id = trim($request->id);
		$result = $db->fetchtaskDetails($id);
		echo json_encode($result);
	}
	
	public function availabilitytypelistAction() {
		$db = new Application_Model_ApiHelper();
		$result = $db->availabilityTypeList();
		echo json_encode($result);
	}
	
	public function fetchavailabilityAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		$result = $db->fetchavailabilitySchedule($request);
		echo json_encode($result);
	}
	
	public function saveavailabilityAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		$result = $db->saveavailabilitySchedule($request);
		echo json_encode($result);
	}
	
	public function agentcontactlistAction() {
		$db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		$result = $db->fetchAgentContactList($request);
		echo json_encode($result);
	}
	
	public function savecontactAction() {
        $db = new Application_Model_ApiHelper();
        $str = file_get_contents('php://input'); 
        $request = json_decode($str);
		$result = $db->saveContact($request);
		echo json_encode($result);
	}
}