<?php

class Application_Model_CustomerHelper extends Application_Model_BaseHelper
{
	var $db;
    public function __construct() {
		$this->db = Zend_Registry::get(DATABASE_SCHEMA);
    }
	
	public function jobStatusList() {
		$sql = "SELECT * FROM ".C3_DB.".`c3_jobstatus` WHERE for_installer = 0;";
		$rs = $this->db->query($sql)->fetchAll();		
		return $rs;
	}
	
	public function addJob($data) {
        try {	
			$refnum = '';
			$sql = "SELECT client_id FROM ".C3_DB.".`c3_customers` WHERE id = ".$data['customer_id'];
			$rsClient = $this->db->query($sql)->fetch();
			
			$sql = "SELECT * FROM ".C3_DB.".`c3_job` ORDER BY job_id DESC LIMIT 1;";
			$rs = $this->db->query($sql)->fetchAll();
			if(count($rs) == 0) {
					$refnum = '1001';
			} else {
				$refnum = (int)$rs[0]['ref_number'] + 1;
			}
			$jobdate = $data['job_fromdate'];
			$sql = "INSERT INTO ".C3_DB.".c3_job SET ref_number = '".$refnum."', client_id = '".$rsClient['client_id']."', job_fromdate = '".$jobdate."', job_todate = '".$jobdate."', customer_id = '".$data['customer_id']."', property_id = '".$data['property_id']."', job_statusid = '".$data['job_statusid']."', jobtype_id = '".$data['jobtype_id']."', technician_id = '".$data['technician_id']."', agent_id = '".$_SESSION['s_auth_agent']['user_id']."', job_details = '".$data['job_details']."', job_amount = '".$data['job_amount']."' ";
			$this->db->query($sql);
			$jobid = $this->db->lastInsertID();
		    
		    return $jobid;
        } catch (Exception $ex) {
            echo $ex->getMessage().$sql;
        }
	}
	
	public function agentJobList() {
		$sql = "SELECT a.*,b.*,c.title as jobStatus,d.skill_title as job_typetitle,c.color,c.fontcolor FROM ".C3_DB.".`c3_job` a LEFT JOIN ".C3_DB.".`c3_customers` b ON(b.id = a.customer_id)  LEFT JOIN ".C3_DB.".`c3_jobstatus` c ON(c.jobStatusID = a.job_statusid) LEFT JOIN ".C3_DB.".`c3_skillset` d ON(d.skill_id = a.jobtype_id) WHERE a.current_status = 1 AND a.agent_id =".$_SESSION['s_auth_agent']['user_id'];
		$rs = $this->db->query($sql)->fetchAll();		
		return $rs;
	}
	
	public function clientJobList($id) {
		$sql = "SELECT a.*,b.*,c.title as jobStatus,d.skill_title as job_typetitle,c.color,c.fontcolor,CONCAT(e.user_fname,' ',e.user_lname) as agent_name,CONCAT(b.first_name,' ',b.last_name) as customer_name,f.lat as client_lat,f.lng as client_lng,f.company,CONCAT(f.address,', ',f.city,' ',f.province,' ',f.zipcode,' ',f.country) as company_address FROM ".C3_DB.".`c3_job` a LEFT JOIN ".C3_DB.".`c3_customers` b ON(b.id = a.customer_id)  LEFT JOIN ".C3_DB.".`c3_jobstatus` c ON(c.jobStatusID = a.job_statusid) LEFT JOIN ".C3_DB.".`c3_skillset` d ON(d.skill_id = a.jobtype_id) LEFT JOIN ".C3_DB.".`c3_users` e ON(e.user_id = a.agent_id) LEFT JOIN ".C3_DB.".`c3_clients` f ON(f.client_id = a.client_id) WHERE a.current_status = 1 AND a.client_id =".$id;
		$rs = $this->db->query($sql)->fetchAll();
		for($i = 0; $i < count($rs); $i++) {
			if($rs[$i]['technician_id'] == 0) {
				$rs[$i]['technician_name'] = '-na-';
			} else {
                $sql = "SELECT CONCAT(f_name,' ',l_name) AS techname  FROM " . C3_DB . ".c3_staff  WHERE staff_id = ".$rs[$i]['technician_id'];
				$rsTech = $this->db->query($sql)->fetch();
				$rs[$i]['technician_name'] = $rsTech['techname'];
			}
			
			
			$rs[$i]['propertylist'] = $this->fetchCustomerProperties($rs[$i]['customer_id']);
			
			$sql = "SELECT COUNT( p.id ) total_properties FROM " . C3_DB . ".c3_properties p WHERE p.customer_id=".$rs[$i]['customer_id'];
			$rec = $this->db->query($sql)->fetch();
			$rs[$i]['total_properties'] = $rec['total_properties'];
			
			$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$rs[$i]['customer_id']." LIMIT 0,1";
			$rec = $this->db->query($sql)->fetch();
			if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
			$rs[$i]['phone_number'] = $ph;
			
			$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$rs[$i]['customer_id']." LIMIT 0,1";
			$rec = $this->db->query($sql)->fetch();
			if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
			$rs[$i]['email'] = $e;
			
			$sql = "SELECT CONCAT(street_1,' ',street_2,', ',city,' ',state,' ',zip_code,' ',country) as defaultaddress,lat,lng FROM ".C3_DB.".c3_properties WHERE 1 AND id = ".$rs[$i]['property_id']." AND default_billing_address = 1 AND property_status = 1 LIMIT 1";
			$rsdefault = $this->db->query($sql)->fetch();
			$rs[$i]['jobaddress'] = $rsdefault['defaultaddress'];
			$rs[$i]['job_lat'] = $rsdefault['job_lat'];
			$rs[$i]['job_lng'] = $rsdefault['job_lng'];
		}
		return $rs;
	}
	
	public function JobProfile($id) {
		$sql = "SELECT a.*,b.*,c.title as jobStatus,d.skill_title as job_typetitle,c.color,c.fontcolor,CONCAT(e.user_fname,' ',e.user_lname) as agent_name,CONCAT(b.first_name,' ',b.last_name) as customer_name,f.lat as client_lat, f.lng as client_lng,f.company,CONCAT(f.address,', ',f.city,' ',f.province,' ',f.zipcode,' ',f.country) as company_address FROM ".C3_DB.".`c3_job` a LEFT JOIN ".C3_DB.".`c3_customers` b ON(b.id = a.customer_id)  LEFT JOIN ".C3_DB.".`c3_jobstatus` c ON(c.jobStatusID = a.job_statusid) LEFT JOIN ".C3_DB.".`c3_skillset` d ON(d.skill_id = a.jobtype_id) LEFT JOIN ".C3_DB.".`c3_users` e ON(e.user_id = a.agent_id) LEFT JOIN ".C3_DB.".`c3_clients` f ON(f.client_id = a.client_id) WHERE a.current_status = 1 AND a.job_id =".$id;
		$rs = $this->db->query($sql)->fetch();
		if($rs['technician_id'] == 0) {
			$rs['technician_name'] = '-na-';
		} else {
			$sql = "SELECT CONCAT(f_name,' ',l_name) AS techname  FROM " . C3_DB . ".c3_staff  WHERE staff_id = ".$rs['technician_id'];
			$rsTech = $this->db->query($sql)->fetch();
			$rs['technician_name'] = $rsTech['techname'];
		}
		
		
		$rs['propertylist'] = $this->fetchCustomerProperties($rs['customer_id']);
		
		$sql = "SELECT COUNT( p.id ) total_properties FROM " . C3_DB . ".c3_properties p WHERE p.customer_id=".$rs['customer_id'];
		$rec = $this->db->query($sql)->fetch();
		$rs['total_properties'] = $rec['total_properties'];
		
		$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$rs['customer_id']." LIMIT 0,1";
		$rec = $this->db->query($sql)->fetch();
		if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
		$rs['phone_number'] = $ph;
		
		$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$rs['customer_id']." LIMIT 0,1";
		$rec = $this->db->query($sql)->fetch();
		if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
		$rs['email'] = $e;
		
		$sql = "SELECT CONCAT(street_1,' ',street_2,', ',city,' ',state,' ',zip_code,' ',country) as defaultaddress,lat,lng FROM ".C3_DB.".c3_properties WHERE 1 AND id = ".$rs['property_id']." AND default_billing_address = 1 AND property_status = 1 LIMIT 1";
		$rsdefault = $this->db->query($sql)->fetch();
		$rs['jobaddress'] = $rsdefault['defaultaddress'];
		$rs['job_lat'] = $rsdefault['lat'];
		$rs['job_lng'] = $rsdefault['lng'];
		return $rs;
	}
	
    public function addCustomer($data = '') {
        $password = rand(time() - 1000, time());
        
        try {
			$chk = 1;
			/* if(!empty($data['email_category'])&&!empty($data['email'])) {
				if($data[email][0] == '') {
					$chk = 1;
				} else {
					$sql = "SELECT id FROM " . C3_DB . ".users WHERE status = 1 AND email='".$data[email][0]."'";
					$result = $this->db->query($sql)->fetchAll();
					if (count($result) > 0) {
						$status['error'] = "This user or email id is already registered with us.";
						$chk = 0;
					} else {
						$chk = 1;
					}
				}
			} else {
				$chk = 1;
			} */
			$client_id = $_SESSION['s_auth_client']['s_user']['client_id'];
			if($chk == 1) {
                $sql = "SELECT c . *,CONCAT_WS(' ', c.first_name, c.last_name) client_name  FROM " . C3_DB . ".c3_customers c  WHERE (c.first_name='$data[first_name]' AND c.last_name='$data[last_name]') ";
                        
						if(!empty($data['company_name'])) {
							$sql .= " OR (c.company_name='$data[company_name]')";//exit;
						}
                $results = $this->db->query($sql)->fetchAll();
				
                if (count($results) < 1 || $data['proceed_anyway']==1) {
                    /* $sql = "INSERT INTO " . C3_DB . ".users SET username='" . $data[email][0] . "', first_name='$data[first_name]', last_name='$data[last_name]', password='" . md5($password) . "', original_password='$password',"
                            . "email='".$data[email][0]."', type='2', creation_date=CURRENT_TIMESTAMP, status=1,account_id=".$_SESSION['auth']['account_id'];
                    $this->db->query($sql);
                    $user_id = $this->db->lastInsertId(); */
					$user_id = 0;
                    $sql = "INSERT INTO " . C3_DB . ".c3_customers SET user_id='$user_id', client_id='$client_id', first_name='$data[first_name]', last_name='$data[last_name]',"
                            . "company_name='$data[company_name]', is_companyname_primary='$data[is_companyname_primary]', referred_by='$data[referred_by]',"
                            . "added_by=0, creation_date=CURRENT_TIMESTAMP, time_zone='$data[time_zone]', currency='$data[currency]'";
                    $this->db->query($sql);
                    $customer_id = $this->db->lastInsertId();
                    
					foreach ($data['phone_number'] as $phone) {
						$this->db->query("INSERT INTO ".C3_DB.".c3_customer_phone SET customer_id='$customer_id',  phone_number='".$phone."'");
					}
                    
                    
					foreach ($data['email'] as $email) {
						$this->db->query("INSERT INTO ".C3_DB.".c3_customer_email SET customer_id='$customer_id',  email='".$email."'");
					}
                    //$default_billing_address = $data['billing_specified'] == 0 ? 0 : 1;
					$default_billing_address = $data['billing_specified'] == 0 ? 1 : 0;
                    if (!empty($data['street1']) || !empty($data['street2']) || !empty($data['city']) || !empty($data['state']) || !empty($data['zip_code']) || !empty($data['country'])) {
                        $sql = "INSERT INTO " . C3_DB . ".c3_properties SET customer_id='$customer_id', street_1='$data[street1]', street_2='$data[street2]', city='$data[city]', lat='$data[lat]',lng='$data[lng]', "
                                . "state='$data[state]', zip_code='$data[zip_code]', country='$data[country]', default_billing_address='$default_billing_address', "
                                . "property_status=1";
                        $this->db->query($sql);
						$property_id = $this->db->lastInsertId();
                    }
                    if (!empty($data['billing_specified'])) {
                        if (!empty($data['billing_street1']) || !empty($data['billing_street2']) || !empty($data['billing_city']) || !empty($data['billing_state']) || !empty($data['billing_zip_code']) || !empty($data['billing_country'])) {
                            $sql = "UPDATE " . C3_DB . ".c3_properties SET default_billing_address=0 WHERE customer_id='$customer_id'";
                            $this->db->query($sql);
                            $sql = "INSERT INTO " . C3_DB . ".c3_properties SET customer_id='$customer_id', street_1='$data[billing_street1]', street_2='$data[billing_street2]', city='$data[billing_city]',  lat='$data[billinglat]',lng='$data[billinglng]', "
                                    . "state='$data[billing_state]', zip_code='$data[billing_zip_code]', country='$data[billing_country]', default_billing_address='1', "
                                    . "property_status=1";
                            $this->db->query($sql);
                        }
                    }
                    $status['success'] = "Successfully created client.";
					$status['cid'] = $customer_id;
					$status['pid'] = $property_id;
                    $_SESSION['msg'] = $status['success'];
                } else {
                    $sql = "SELECT c . *,CONCAT_WS(' ', c.first_name, c.last_name) client_name , COUNT( p.id ) total_c3_properties, (SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = c.id LIMIT 1) phone_number FROM " . C3_DB . ".c3_customers c LEFT JOIN  " . C3_DB . ".`c3_properties` p ON ( c.id = p.customer_id )  WHERE (c.first_name='$data[first_name]' AND c.last_name='$data[last_name]') OR "
                        . "(c.company_name='$data[company_name]')";//exit;
                    $results = $this->db->query($sql)->fetchAll();
                    $status['results'] = $results;
                }
			}
			return $status;
        } catch (Exception $ex) {
            $status['error'] = $ex->getMessage().$sql;
			return $status;
        }
        
    }

    public function getProperty($customer_id) {
        try {
            $sql = "SELECT p.*,c.country_name FROM ".C3_DB.".c3_properties p LEFT JOIN ".C3_DB.".c3_country c on(c.id = p.country) WHERE p.customer_id='$customer_id' AND p.property_status = 1 ORDER BY p.default_billing_address DESC LIMIT 1";
            return $result = $this->db->query($sql)->fetch();
        } catch (Exception $ex) {
            echo $ex->getMessage().$sql;
        }
    }
	
	public function fetchCustomerUploadsnInfo($id) {
		$sql = "SELECT a.*,b.uploadtype_title FROM ".C3_DB.".`c3_customerprofile_uploads` a LEFT JOIN ".C3_DB.".`c3_uploadtypes` b ON(b.uploadtype_id = a.uploadtype_id) WHERE a.current_status = 1 AND a.customer_id = ".$id;
		$rsUploads = $this->db->query($sql)->fetchAll();
		$sql = "SELECT * FROM ".C3_DB.".c3_customerprofile_extrainfo WHERE current_status = 1 AND customer_id = ".$id;
		$rsInfo = $this->db->query($sql)->fetchAll();
		$arr = array (
			'uploads' => $rsUploads,
			'info' => $rsInfo
		);
		return $arr;
	}
	
	public function uploadCustomerFile($data,$filename) {
		$sql = "INSERT INTO ".C3_DB.".c3_customerprofile_uploads SET customer_id = '".$data['hdnUploadCustomerID']."', uploadtype_id = '".$data['uploadtype_id']."', file_name = '".$filename."';";
		$this->db->query($sql);
		return $data['hdnUploadStaffID'];
	}
	
	public function saveCustomerInfo($data) {
		$sql = "INSERT INTO ".C3_DB.".c3_customerprofile_extrainfo SET customer_id = '".$data['hdnInfoCustomerID']."', 	info_title = '".$data['info_title']."', info_desc = '".$data['info_desc']."';";
		$this->db->query($sql);
		return $data['hdnInfoStaffID'];
	}
	
	public function removeCustomerUpload($id) {
		$sql = "UPDATE ".C3_DB.".c3_customerprofile_uploads SET current_status = 0 WHERE upload_id = ".$id;
		$this->db->query($sql);	
		return 1;
	}
	
	public function removeCustomerExtraInfo($id) {
		$sql = "UPDATE ".C3_DB.".c3_customerprofile_extrainfo SET current_status = 0 WHERE info_id = ".$id;
		$this->db->query($sql);	
		return 1;
	}
	
	public function removeCustomerProperty($id) {
		$sql = "UPDATE ".C3_DB.".c3_properties SET property_status = 0 WHERE id = ".$id;
		$this->db->query($sql);	
		return 1;
	}
	
	public function getCustomerPhoneEmail($id) {
		$r = array();
		$cond = " AND id =".$id;
		$sql = "SELECT c.*, CONCAT_WS(' ',c.first_name, c.last_name) customer_name FROM " . C3_DB . ".c3_customers c WHERE 1 ";
		$sql .= " AND CONCAT_WS(' ', c.first_name, c.last_name)<>'' ";
		$sql .= $cond;
		$sql.=" ORDER BY c.id DESC";
		$rs = $this->db->query($sql)->fetch();
		$r['customer_name'] = $rs['customer_name'];
		
		$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$id." LIMIT 0,1";
		$rec = $this->db->query($sql)->fetch();
		if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
		$r['phone_number'] = $ph;
		
		$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$id." LIMIT 0,1";
		$rec = $this->db->query($sql)->fetch();
		if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
		$r['email'] = $e;
		return $r;
	}
	
    public function fetchCustomers($id,$client_id) {
        try {
			$cond = '';
			if($client_id != 0) {
				$cond = " AND c.client_id =".$client_id;
			}
			
			if($id == 0) {
				$cond .= "";
			} else {
				$cond .= " AND c.id =".$id;
			}
			$sql = "SELECT c.*, CONCAT_WS(' ',c.first_name, c.last_name) customer_name, d.company FROM " . C3_DB . ".c3_customers c LEFT JOIN " . C3_DB . ".c3_clients d ON(d.client_id = c.client_id) WHERE 1 ";
			
			$sql .= " AND CONCAT_WS(' ', c.first_name, c.last_name)<>'' ";
            $sql .= $cond;
            $sql.=" ORDER BY c.id DESC";
			$results = array();
            $rs = $this->db->query($sql)->fetchAll();
			if(count($rs) > 0) {
				$index = 0;
				foreach($rs as $r) {
					$r['propertylist'] = $this->fetchCustomerProperties($r['id']);
					
					$sql = "SELECT COUNT( p.id ) total_properties FROM " . C3_DB . ".c3_properties p WHERE p.customer_id=".$r['id'];
					$rec = $this->db->query($sql)->fetch();
					$r['total_properties'] = $rec['total_properties'];
					
					$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$r['id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
					$r['phone_number'] = $ph;
					
					$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$r['id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
					$r['email'] = $e;
					
					$sql = "SELECT CONCAT(street_1,' ',street_2,', ',city,' ',state,' ',zip_code,' ',country) as defaultaddress FROM ".C3_DB.".c3_properties WHERE 1 AND customer_id = ".$r['id']." AND default_billing_address = 1 AND property_status = 1 LIMIT 1";
					$rsdefault = $this->db->query($sql)->fetch();
					$r['defaultaddress'] = $rsdefault['defaultaddress'];
					
					$results[$index]=$r;
					$index++;
				}
				
				return $results;
			} else {
				return 0;
			}
        } catch (Exception $e) {
            return 0;
        }
    }
	
    public function fetchCustomersById($id) {
        try {
			$cond = "";
			if($id == 0) {
				$cond .= "";
			} else {
				$cond .= " AND c.id =".$id;
			}
			$sql = "SELECT c.*, CONCAT_WS(' ',c.first_name, c.last_name) customer_name, d.company FROM " . C3_DB . ".c3_customers c LEFT JOIN " . C3_DB . ".c3_clients d ON(d.client_id = c.client_id) WHERE 1 ";
			
			$sql .= " AND CONCAT_WS(' ', c.first_name, c.last_name)<>'' ";
            $sql .= $cond;
            $sql.=" ORDER BY c.id DESC";
			$results = array();
            $rs = $this->db->query($sql)->fetchAll();
			if(count($rs) > 0) {
				$index = 0;
				foreach($rs as $r) {
					$r['propertylist'] = $this->fetchCustomerProperties($r['id']);
					
					$sql = "SELECT COUNT( p.id ) total_properties FROM " . C3_DB . ".c3_properties p WHERE p.customer_id=".$r['id'];
					$rec = $this->db->query($sql)->fetch();
					$r['total_properties'] = $rec['total_properties'];
					
					$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$r['id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
					$r['phone_number'] = $ph;
					
					$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$r['id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
					$r['email'] = $e;
					
					$sql = "SELECT CONCAT(street_1,' ',street_2,', ',city,' ',state,' ',zip_code,' ',country) as defaultaddress FROM ".C3_DB.".c3_properties WHERE 1 AND customer_id = ".$r['id']." AND default_billing_address = 1 AND property_status = 1 LIMIT 1";
					$rsdefault = $this->db->query($sql)->fetch();
					$r['defaultaddress'] = $rsdefault['defaultaddress'];
					
					$results[$index]=$r;
					$index++;
				}
				
				return $results;
			} else {
				return 0;
			}
        } catch (Exception $e) {
            return 0;
        }
    }
	
    public function fetchCustomerByPhone($phone) {
        try {
			$cond = "";
			if($phone == '') {
				$cond .= "";
			} else {
				$cond .= " AND c.id =".$id;
			}
			$sql = "SELECT DISTINCT customer_id FROM " . C3_DB . ".c3_customer_phone  WHERE status = 1 AND REPLACE(phone_number,'-','') = '".$phone."'";
			$results = array();
            $rsIds = $this->db->query($sql)->fetchAll();
			
			
			if(count($rsIds) > 0) {
				$index = 0;
				foreach($rsIds as $r) {
					$sql = "SELECT c.*, CONCAT_WS(' ',c.first_name, c.last_name) customer_name, d.company FROM " . C3_DB . ".c3_customers c LEFT JOIN " . C3_DB . ".c3_clients d ON(d.client_id = c.client_id) WHERE 1 ";
					
					$sql .= " AND CONCAT_WS(' ', c.first_name, c.last_name)<>'' AND c.id = ".$r['customer_id'];
					$sql.=" ORDER BY c.first_name ASC";
					$rCustomer = $this->db->query($sql)->fetch();
					$rCustomer['propertylist'] = $this->fetchCustomerProperties($r['customer_id']);
					
					$sql = "SELECT COUNT( p.id ) total_properties FROM " . C3_DB . ".c3_properties p WHERE p.customer_id=".$r['customer_id'];
					$rec = $this->db->query($sql)->fetch();
					$rCustomer['total_properties'] = $rec['total_properties'];
					
					$sql = "SELECT phone_number FROM " . C3_DB . ".c3_customer_phone WHERE customer_id = ".$r['customer_id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['phone_number'])) { $ph = ''; } else { $ph = $rec['phone_number']; }
					$rCustomer['phone_number'] = $ph;
					
					$sql = "SELECT email FROM " . C3_DB . ".c3_customer_email WHERE customer_id = ".$r['customer_id']." LIMIT 0,1";
					$rec = $this->db->query($sql)->fetch();
					if(is_null($rec['email'])) { $e = ''; } else { $e = $rec['email']; }
					$rCustomer['email'] = $e;
					
					$sql = "SELECT CONCAT(street_1,' ',street_2,', ',city,' ',state,' ',zip_code,' ',country) as defaultaddress FROM ".C3_DB.".c3_properties WHERE 1 AND customer_id = ".$r['customer_id']." AND default_billing_address = 1 AND property_status = 1 LIMIT 1";
					$rsdefault = $this->db->query($sql)->fetch();
					$rCustomer['defaultaddress'] = $rsdefault['defaultaddress'];
					
					$results[$index]=$rCustomer;
					$index++;
				}
				
				return $results;
			} else {
				return 0;
			}
        } catch (Exception $e) {
            return 0;
        }
    }
	
    public function getTimezones() {
        try {
            $sql = "SELECT * FROM ".C3_DB.".c3_zone";
            return $this->db->query($sql)->fetchAll();
        } catch (Exception $ex) {
            
        }
    }
    
    public function getCurrency() {
        try {
            $sql = "SELECT * FROM ".C3_DB.".c3_currency";
            return $this->db->query($sql)->fetchAll();
        } catch (Exception $ex) {
            
        }
    }
	
	public function getCountries() {
		try {
            $sql = "SELECT * FROM ".C3_DB.".c3_country";
            return $this->db->query($sql)->fetchAll();
        } catch (Exception $ex) {
            
        }
	}
	
	public function addProperty($data) {
        try {
			$id = 0;
			if($data['hdnAction'] == 'I') {
				$default_billing_address = 1;
				if($data['default_billing_address'] == '') {
					$default_billing_address = 0;					
				}
				
				if($data['hdnID'] == '0') {
					$sql = "INSERT INTO ".C3_DB.".c3_properties SET customer_id = ".$data['hdnClientid'].", street_1 = '".$data['street_1']."', street_2 = '".$data['street_2']."', city = '".$data['city']."', state = '".$data['state']."', zip_code = '".$data['zip_code']."', country = '".$data['countryname']."', lat = '".$data['latitude']."', lng = '".$data['longitude']."', default_billing_address = '".$default_billing_address."'; ";
					$id = $this->db->lastInsertID();
				} else {
					$sql = "UPDATE ".C3_DB.".c3_properties SET street_1 = '".$data['street_1']."', street_2 = '".$data['street_2']."', city = '".$data['city']."', state = '".$data['state']."', zip_code = '".$data['zip_code']."', country = '".$data['countryname']."', lat = '".$data['latitude']."', lng = '".$data['longitude']."', default_billing_address = '".$default_billing_address."' WHERE id = ".$data['hdnID'];
					$id = $data['hdnID'];
				}
			} else {				
				$sql = "SELECT property_status FROM ".C3_DB.".`c3_properties` WHERE id = ".$data['hdnID'];
				$user = $this->db->query($sql)->fetch();
				$status = 0;
				if($user['property_status'] == 0) {
					$status = 1;
				} else {
					$status = 0;
				}
				$sql = "UPDATE ".C3_DB.".c3_properties SET property_status = ".$status." WHERE id = ".$data['hdnID'];
				$id = $data['hdnID'];
			}
		    $this->db->query($sql);
		    return $id;
        } catch (Exception $ex) {
            echo $ex->getMessage().$sql;
        }
	}
	
	public function fetchCustomerProperties($customer_id) {
		try {
            $sql = "SELECT * FROM ".C3_DB.".c3_properties WHERE 1 AND property_status = 1 AND customer_id = ".$customer_id;
            return $this->db->query($sql)->fetchAll();
        } catch (Exception $ex) {
            
        }
	}
	
	public function fetchPropertyDetails($property_id) {
		try {
            $sql = "SELECT * FROM ".C3_DB.".c3_properties WHERE 1 AND id = ".$property_id;
            return $this->db->query($sql)->fetch();
        } catch (Exception $ex) {
            
        }
	}
}

