<?php
class Application_Model_TicketHelper extends Application_Model_BaseHelper {
	var $db;
    public function __construct() {
		$this->db = Zend_Registry::get(DATABASE_SCHEMA);
    }
	
	public function getPriorities() {
	    $sql = "SELECT * FROM `c3_ticket_priorities`";
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function getPriorityByID($pID) {
	    $sql = "SELECT * FROM `c3_ticket_priorities` WHERE `tkt_prior_id`=".$pID;
	    return $this->db->query($sql)->fetch();
	}
	
	public function saveTicket($data) {
		$today = date('Y-m-d H:i:s');
		$sql = "INSERT INTO `c3_tickets` (`tkt_cdate`, `tkt_created_by`, `tkt_last_updated`, `tkt_last_updated_by`, `tkt_subject`, `tkt_priority`, `tkt_details`, `tkt_customer_id`, `tkt_client_id`, `tkt_resolver_id`) VALUES ('".$today."', 2, '".$today."', 2, '".addslashes(trim($data['txtSubject']))."', ".$data['selPriority'].", '".addslashes(trim($data['txtDesc']))."', ".$data['hdnCustomerID'].", ".$data['hdnClientID'].", ".$data['selResolver'].")";
		$this->db->query($sql);
		$ticketID = $this->db->lastInsertID();
		return $ticketID;
	}
	
	public function getTickets($clientID, $customerID=0, $q='') {
	    $cond = ' AND a.`tkt_client_id`='.$clientID;
	    if($customerID!='') {
	        $cond.= ' AND a.`tkt_customer_id`='.$customerID;
	    }
	    if(trim($q)!='') {
	        
	    }
	    $sql = "SELECT a.*,b.status_title, b.status_color,c.tkt_prior_title,d.*,e.company FROM `c3_tickets` a, c3_ticket_status b, c3_ticket_priorities c, c3_customers d, c3_clients e WHERE 1 AND b.status_id = a.tkt_status AND c.tkt_prior_id = a.tkt_priority AND d.id = a.tkt_customer_id AND e.client_id = a.tkt_client_id ".$cond." ORDER BY a.`tkt_id`";		
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function getTicketsByRole() {
		switch($_SESSION['rolekey']) {
			case 'admin':
				$sql = "SELECT a.*,b.status_title, b.status_color,c.tkt_prior_title,d.*,e.company FROM `c3_tickets` a, c3_ticket_status b, c3_ticket_priorities c, c3_customers d, c3_clients e WHERE 1 AND b.status_id = a.tkt_status AND c.tkt_prior_id = a.tkt_priority AND d.id = a.tkt_customer_id AND e.client_id = a.tkt_client_id ORDER BY a.tkt_id DESC";
			break;
			case 'agent':
				$sql = "SELECT a.*,b.status_title, b.status_color,c.tkt_prior_title,d.*,e.company FROM `c3_tickets` a, c3_ticket_status b, c3_ticket_priorities c, c3_customers d, c3_clients e WHERE 1 AND a.tkt_created_by = ".$_SESSION['s_auth_agent']['user_id']." AND b.status_id = a.tkt_status AND c.tkt_prior_id = a.tkt_priority AND d.id = a.tkt_customer_id AND e.client_id = a.tkt_client_id ORDER BY a.tkt_id DESC";
			break;
			case 'client':
				$sql = "SELECT a.*,b.status_title, b.status_color,c.tkt_prior_title,d.*,e.company FROM `c3_tickets` a, c3_ticket_status b, c3_ticket_priorities c, c3_customers d, c3_clients e WHERE 1 AND e.user_id = ".$_SESSION['s_auth_client']['user_id']." AND a.tkt_client_id = e.client_id AND b.status_id = a.tkt_status AND c.tkt_prior_id = a.tkt_priority AND d.id = a.tkt_customer_id AND e.client_id = a.tkt_client_id ORDER BY a.tkt_id DESC";
			break;
			default:
				$sql = "SELECT a.*,b.status_title, b.status_color,c.tkt_prior_title,d.*,e.company FROM `c3_tickets` a, c3_ticket_status b, c3_ticket_priorities c, c3_customers d, c3_clients e WHERE 1 AND b.status_id = a.tkt_status AND c.tkt_prior_id = a.tkt_priority AND d.id = a.tkt_customer_id AND e.client_id = a.tkt_client_id ORDER BY a.tkt_id DESC";
			break;
		}
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function getQueues($clientID) {
	    $sql = "SELECT a.*,b.res_name,b.res_email,b.res_phone FROM `c3_ticket_queues` a, c3_ticket_resolvers b WHERE b.res_id = a.res_id AND  a.`res_client_id`=".$clientID;
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function saveQueue($data) {
	    if($data['id']==0) { //New Resolver
	        $sql = "INSERT INTO `c3_ticket_queues` (`res_client_id`) VALUES (".$data['clientID'].")";
	        $this->db->query($sql);
	        $data['id'] = $this->db->lastInsertId(); 
	    }
	    
	    $sql = "UPDATE `c3_ticket_queues` SET 
	            `queue_title`='".addslashes(trim($data['queue_title']))."',
	            `res_id`='".addslashes(trim($data['res_id']))."',
	            `escalation_threshold`='".addslashes(trim($data['escalation_threshold']))."' 
	            WHERE `queue_id`=".$data['id'];
	    if($this->db->query($sql)) {
	      $arr = array('code'=>1, 'msg'=>'Queue saved successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Queue cannot be saved. Please try again later.');
	    }
	    return $arr;
	}
	
	public function getQueueByID($ID) {
	     $sql = "SELECT * FROM `c3_ticket_queues` WHERE `queue_id`=".$ID;
	      return $this->db->query($sql)->fetch();
	}
	
	public function changeQueueStatus($ID) {
	    $queue = $this->getQueueByID($ID);
	    $newStatus = 0;
	    if($queue['current_status']==0) {
	        $newStatus = 1;
	    }
	    $sql = "UPDATE `c3_ticket_queues` SET `current_status`=".$newStatus." WHERE `queue_id`=".$ID;
	    if($this->db->query($sql)) {
	      $arr = array('code'=>1, 'msg'=>'Queue Status changed successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Queue Status cannot be changed. Please try again later.');
	    }
	    return $arr;
	}
	/*** RESOLVERS ***/
	public function getResolvers($clientID) {
	    $sql = "SELECT * FROM `c3_ticket_resolvers` WHERE `res_client_id`=".$clientID;
	    //die();
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function getResolverByID($resID) {
	     $sql = "SELECT * FROM `c3_ticket_resolvers` WHERE `res_id`=".$resID;
	      return $this->db->query($sql)->fetch();
	}
	
	public function changeResolverStatus($resID) {
	    $resolver = $this->getResolverByID($resID);
	    $newStatus = 0;
	    if($resolver['res_status']==0) {
	        $newStatus = 1;
	    }
	    $sql = "UPDATE `c3_ticket_resolvers` SET `res_status`=".$newStatus." WHERE `res_id`=".$resID;
	    if($this->db->query($sql)) {
	      $arr = array('code'=>1, 'msg'=>'Resolver Status changed successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Resolver Status cannot be changed. Please try again later.');
	    }
	    return $arr;
	}
	
	public function saveResolver($data) {
	    if($data['id']==0) { //New Resolver
	        $sql = "INSERT INTO `c3_ticket_resolvers` (`res_client_id`) VALUES (".$data['clientID'].")";
	        $this->db->query($sql);
	        $data['id'] = $this->db->lastInsertId(); 
	    }
	    
	    $sql = "UPDATE `c3_ticket_resolvers` SET 
	            `res_name`='".addslashes(trim($data['name']))."',
	            `res_email`='".addslashes(trim($data['email']))."',
	            `res_phone`='".addslashes(trim($data['phone']))."',
	            `res_whatsapp`='".addslashes(trim($data['whatsapp']))."',
	            `res_skype`='".addslashes(trim($data['skype']))."',
	            `res_viber`='".addslashes(trim($data['viber']))."' 
	            WHERE `res_id`=".$data['id'];
	    if($this->db->query($sql)) {
	      $arr = array('code'=>1, 'msg'=>'Resolver saved successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Resolver cannot be saved. Please try again later.');
	    }
	    return $arr;
	}
	/*** RESOLVERS ***/
	
	/*** STATUSES ***/
	public function getStatuses($clientID) {
	    $sql = "SELECT * FROM `c3_ticket_status` WHERE `status_client_id`=".$clientID;
	    return $this->db->query($sql)->fetchAll();
	}
	
	public function getStatusByID($statusID) {
	     $sql = "SELECT * FROM `c3_ticket_status` WHERE `status_id`=".$statusID;
	      return $this->db->query($sql)->fetch();
	}
	
	public function changeStatusStatus($statusID) {
	    $status = $this->getStatusByID($statusID);
	    $newStatus = 0;
	    if($status['status_is_active']==0) {
	        $newStatus = 1;
	    }
	    $sql = "UPDATE `c3_ticket_status` SET `status_is_active`=".$newStatus." WHERE `status_id`=".$statusID;
	    if($this->db->query($sql)) {
	      $arr = array('code'=>1, 'msg'=>'Status changed successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Status cannot be changed. Please try again later.');
	    }  
	    return $arr;
	}
	
	public function saveStatus($data) {
	    if($data['id']==0) { //New Status
	        $sql = "INSERT INTO `c3_ticket_status` (`status_title`, `status_color`, `status_client_id`) VALUES ('".addslashes(trim($data['title']))."', '".addslashes(trim($data['color']))."', ".$data['client'].")";
	    } else { //Update
	        $sql = "UPDATE `c3_ticket_status` SET `status_title`='".addslashes(trim($data['title']))."', `status_color`='".addslashes(trim($data['color']))."' WHERE `status_id`=".$data['id'];
	    }
	    
	    if($this->db->query($sql)) {
	        $arr = array('code'=>1, 'msg'=>'Ticket Status saved successfully.');
	    } else {
	        $arr = array('code'=>0, 'msg'=>'Ticket Status cannot be saved. Please try again later.');
	    }
	    return $arr;
	}
	/*** STATUSES ***/
}

