<?php
class Client_CustomerController extends Zend_Controller_Action {
	
    public function init() {
        session_start();
		$this->view->browserTitle = APPLICATION_TITLE;
		$this->view->layoutMode = "light";
		$this->_helper->layout->setLayout('layout-client');	
    }

    public function indexAction() {
        $this->view->pageTitle = "Customers";
		$db = new Application_Model_CustomerHelper();
		$this->view->customerList = $db->fetchCustomers(0,$_SESSION['s_auth_client']['s_user']['client_id']);
    }
	
    public function customerdetailsAction() {
        $this->view->pageTitle = "Customer Details";
		$db = new Application_Model_CustomerHelper();
		$this->view->id = $this->getRequest()->getParam('id');
        $rs = $db->fetchCustomers($this->view->id);
		$this->view->customer = $rs[0];
    }
	
    public function customerprofileAction()
    {
        $this->view->pageTitle = "Profile";
		$this->view->id = 0;
		if($this->getRequest()->getParam('id')) {
			$this->view->id = $this->getRequest()->getParam('id');
		}
		
		$dbCustomer = new Application_Model_CustomerHelper();
		
        if ($this->getRequest()->isPost()) {
			if($this->getRequest()->getPost('btnupload')) {
				if(!empty($_FILES['file_name']['tmp_name'])) {
					$filename = $_FILES['file_name']['tmp_name'];
				} else {
					$filename = 'na';
				}
				$result = $dbCustomer->uploadCustomerFile($this->getRequest()->getPost(),$filename);
				$this->view->id = $result;
			}
			
			if($this->getRequest()->getPost('btnsave')) {
				$result = $dbCustomer->saveCustomerInfo($this->getRequest()->getPost());
				$this->view->id = $result;
			}
			$this->_redirect('/client/staff/staffprofile?id='.$this->view->id);
		}
		
		if($this->view->id > 0) {
			$profile = $dbCustomer->fetchCustomers($this->view->id,0);
			$this->view->profile = $profile[0];
			if($this->view->profile == 0) {
				$this->view->id = 0;
			} else {
				$dbStaff = new Application_Model_StaffHelper();
				$this->view->uploadTypes = $dbStaff->fetchStaffsUploadTypes($this->view->id);
				$this->view->customerData = $dbCustomer->fetchCustomerUploadsnInfo($this->view->id);
			}
		}
    }
	
	public function removeuploadAction() {
		$this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$db = new Application_Model_CustomerHelper();
		$id = $this->getRequest()->getParam('id');
		$result = $db->removeCustomerUpload($id);
		echo $result;
	}
	
	public function removeinfoAction() {
		$this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$db = new Application_Model_CustomerHelper();
		$id = $this->getRequest()->getParam('id');
		$result = $db->removeCustomerExtraInfo($id);
		echo $result;
	}
	
	public function removepropertyAction() {
		$this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$db = new Application_Model_CustomerHelper();
		$id = $this->getRequest()->getParam('id');
		$result = $db->removeCustomerProperty($id);
		echo $result;
	}
	
	public function sendmessageAction() {
		//$this->_helper->layout->setLayout('layout-blank');
		$dbCustomer = new Application_Model_CustomerHelper();
		$id = $this->getRequest()->getParam('id');
		
		$rs = $dbCustomer->getCustomerPhoneEmail($id);
		$this->view->pageTitle = "Send Message : <a href='".WEB_SERVER_ROOT."client/customer/customerprofile?id=".$id."'>".$rs['customer_name']."</a>";
		
		$this->view->toemail = $rs['email'];
		$this->view->tophone = $rs['phone_number'];	
		$arr = array();
		if(isset($_POST["btnemail"])) {
			$to = $this->getRequest()->getParam('txtto');
			$from = $this->getRequest()->getParam('txtfrom');
			$subject = $this->getRequest()->getParam('txtsubject');
			$body = $this->getRequest()->getParam('txtbody');
			$smtpconfig = array('auth' => 'login', 'username' => 'c3noreply@otscom.net', 'password' => 'Zx]9Yd7-=$8V', 'port' => 587);
			$smtptransport = new Zend_Mail_Transport_Smtp('mail.otscom.net', $smtpconfig);
			$mail = new Zend_Mail();
			$mail->setBodyHtml($body);
			//$mail->setFrom("it@simplyportals.com","Energy Experts");
			$mail->setFrom($from,"Energy Experts");
			$mail->addTo($to, '');
			$mail->setSubject($subject);
			$mail->send($smtptransport);
		} else if(isset($_POST["btnsms"])) {
			$to = $this->getRequest()->getParam('txttoph');
			$body = $this->getRequest()->getParam('txtbody');
			$postURL = 'https://twilio.simplyportals.ca/index.php?to='.urlencode($to).'&body='.urlencode($body);
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, $postURL);
			curl_setopt($ch,CURLOPT_HTTPHEADER, Array("Content-Type: text/plain; charset=utf-8")); 
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, 1); 
			curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($ch,CURLOPT_SSL_VERIFYHOST, 0);
			$result = curl_exec($ch);
			curl_close($ch);
			//print_r($result);die();
		}
		
		/* if ($this->getRequest()->isPost()) {
			if($this->getRequest()->getParam('btnemail')) {
				
				$to = $this->getRequest()->getParam('txtto');
				$from = $this->getRequest()->getParam('txtfrom');
				$subject = $this->getRequest()->getParam('txtsubject');
				$body = $this->getRequest()->getParam('txtbody');
				$smtpconfig = array('auth' => 'login', 'username' => 'error@simplyportals.com', 'password' => 'CVFov9HE', 'port' => 587);
				$smtptransport = new Zend_Mail_Transport_Smtp('mail.simplyportals.com', $smtpconfig);
				$mail = new Zend_Mail();
				$mail->setBodyHtml($body);
				//$mail->setFrom("it@simplyportals.com","Energy Experts");
				$mail->setFrom($from,"Energy Experts");
				$mail->addTo($to, '');
				$mail->setSubject($subject);
				$mail->send($smtptransport);
			}
			
			if($this->getRequest()->getParam('btnsms')) {
				
				$to = $this->getRequest()->getParam('txttoph');
				$body = $this->getRequest()->getParam('txtbody');
			}
		} */
	}
	
    public function newcustomerAction() {
        $this->view->pageTitle = "New Customer";
		$db = new Application_Model_CustomerHelper();
        $this->view->timezones = $db->getTimezones();
        $this->view->currency = $db->getCurrency();
		$this->view->countries = $db->getCountries();
    }
	
	public function addcustomerAction() {
        $this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
        $post = array();
		$post['added_by'] = $_SESSION['auth']['id'];
        $json = array('error'=>"", 'success'=>"");
        $post['first_name'] = addslashes($this->getRequest()->getParam('first_name'));
        $post['last_name'] = addslashes($this->getRequest()->getParam('last_name'));
        $post['company_name'] = addslashes($this->getRequest()->getParam('company_name'));
        if($this->getRequest()->getParam('is_companyname_primary'))
            $post['is_companyname_primary'] = 1;
        else 
            $post['is_companyname_primary'] = 0;
        
        $post['phone_number'] = $this->getRequest()->getParam('phone_number');
        $post['email'] = $this->getRequest()->getParam('email');
        $post['referred_by'] = addslashes($this->getRequest()->getParam('referred_by'));
        $post['street1'] = addslashes($this->getRequest()->getParam('street1'));
        $post['street2'] = addslashes($this->getRequest()->getParam('street2'));
        $post['city'] = addslashes($this->getRequest()->getParam('city'));
        $post['state'] = addslashes($this->getRequest()->getParam('state'));
        $post['zip_code'] = addslashes($this->getRequest()->getParam('zip_code'));
        $post['country'] = $this->getRequest()->getParam('country');
		$address = $post['street1'].', '. $post['street2'].' '.$post['city'].' '.$post['state'].' '.$post['zip_code'].' '.$post['country'];
		$strlatlng = $this->get_lat_long($address);
		$arrlatlng = explode(',',$strlatlng);
		$post['lat'] = $arrlatlng[0];
		$post['lng'] = $arrlatlng[1];
		
        $post['billing_street1'] = addslashes($this->getRequest()->getParam('billing_street1'));
        $post['billing_street2'] = addslashes($this->getRequest()->getParam('billing_street2'));
        $post['billing_city'] = addslashes($this->getRequest()->getParam('billing_city'));
        $post['billing_state'] = addslashes($this->getRequest()->getParam('billing_state'));
        $post['billing_zip_code'] = addslashes($this->getRequest()->getParam('billing_zip_code'));
        $post['billing_country'] = $this->getRequest()->getParam('billing_country');
        $post['billing_specified'] = $this->getRequest()->getParam('billing_specified');
		$address = $post['billing_street1'].', '. $post['billing_street2'].' '.$post['billing_city'].' '.$post['billing_state'].' '.$post['billing_zip_code'].' '.$post['billing_country'];
		$strlatlng = $this->get_lat_long($address);
		$arrlatlng = explode(',',$strlatlng);
		$post['billinglat'] = $arrlatlng[0];
		$post['billinglng'] = $arrlatlng[1];
        $post['added_by'] = $_SESSION['auth']['id'];
        if($this->getRequest()->getParam('proceed_anyway')) {
            $post['proceed_anyway'] = $this->getRequest()->getParam('proceed_anyway');
        } else {
            $post['proceed_anyway'] = 0;
        }
        $post['time_zone'] = $this->getRequest()->getParam('time_zone');
        $post['currency'] = $this->getRequest()->getParam('currency');
        
        $db = new Application_Model_CustomerHelper();
        $status = $db->addCustomer($post);
        $json['error'] = isset($status['error'])?$status['error']:"";
        $json['success'] = isset($status['success'])?$status['success']:"";
        $json['results'] = isset($status['results'])?$status['results']:"";
		$json['latlng'] = $strlatlng;
        echo json_encode($json);
    }
	
	function get_lat_long($address){
		$address = str_replace(" ", "+", $address);

		$json = file_get_contents("https://maps.google.com/maps/api/geocode/json?address=".urlencode($address)."&sensor=false&key=AIzaSyC_62Grmjuck18gpaAA2MN0dw5XdBhwAOM");
		$json = json_decode($json);
		$lat = $json->{'results'}[0]->{'geometry'}->{'location'}->{'lat'};
		$long = $json->{'results'}[0]->{'geometry'}->{'location'}->{'lng'};
		return $lat.','.$long;
	}

    public function newpropertyAction()
    {
        $this->view->pageTitle = "Add Property";
		$dbCustomer = new Application_Model_CustomerHelper();
		if($this->getRequest()->getParam('id')) {
			$this->view->id = $this->getRequest()->getParam('id');
		} else {
			$this->view->id = 0;
		}
		
		if($this->getRequest()->getParam('client_id')) {
			$this->view->client_id = $this->getRequest()->getParam('client_id');
		} else {
			$this->view->client_id = 0;
		}
		
        if ($this->getRequest()->isPost()) {
			$result = $dbCustomer->addProperty($this->getRequest()->getPost());
			$this->view->id = $result;
			$this->_redirect("client/customer/");
		}
		$this->view->property = $dbCustomer->fetchPropertyDetails($this->view->id);
    }
	
	public function joblistAction()
    {
		$this->view->pageTitle = "Jobs";
		$dbCustomer = new Application_Model_CustomerHelper();
		
		$this->view->jobList = $dbCustomer->clientJobList($_SESSION['s_auth_client']['s_user']['client_id']);
		$this->view->jobStatusList = $dbCustomer->jobStatusList();
	}
	
	public function jobprofileAction()
    {
		$dbCustomer = new Application_Model_CustomerHelper();
		$this->view->id = 0;
		if($this->getRequest()->getParam('id')) {
			$this->view->id = $this->getRequest()->getParam('id');
		}
		$this->view->profile = $dbCustomer->JobProfile($this->view->id);
		$this->view->pageTitle = "Job: #".$this->view->profile['ref_number'];
		$this->view->jobStatusList = $dbCustomer->jobStatusList();
	}
}