<?php
class Client_StaffController extends Zend_Controller_Action {
	
    public function init() {
        session_start();
		$this->view->browserTitle = APPLICATION_TITLE;
		$this->view->layoutMode = "light";
		$this->_helper->layout->setLayout('layout-client');	
    }

    public function indexAction() {
        $this->view->pageTitle = "Staff";
		$dbStaff = new Application_Model_StaffHelper();
		$this->view->id = 0;
        if ($this->getRequest()->isPost()) {
			$address = $this->getRequest()->getParam('address').', '. $this->getRequest()->getParam('city').' '.$this->getRequest()->getParam('province').' '.$this->getRequest()->getParam('zipcode').' '.$this->getRequest()->getParam('country');
			$strlatlng = $this->get_lat_long($address);
			$arrlatlng = explode(',',$strlatlng);
			$result = $dbStaff->addStaff($this->getRequest()->getPost(),$arrlatlng[0],$arrlatlng[1]);
			$this->view->id = $result;
		}
		$this->view->skillsetList = $dbStaff->fetchStaffsSkillset('',$_SESSION['s_auth_client']['s_user']['client_id']);
		$this->view->staffList = $dbStaff->fetchStaffs('',$_SESSION['s_auth_client']['s_user']['client_id']);
    }
	
	function get_lat_long($address){
		$address = str_replace(" ", "+", $address);
		$URL = "https://maps.google.com/maps/api/geocode/json?address=".urlencode($address)."&sensor=false&key=AIzaSyC_62Grmjuck18gpaAA2MN0dw5XdBhwAOM";
		$json = file_get_contents("https://maps.google.com/maps/api/geocode/json?address=".urlencode($address)."&sensor=false&key=AIzaSyC_62Grmjuck18gpaAA2MN0dw5XdBhwAOM");
		$json = json_decode($json);
		$lat = $json->{'results'}[0]->{'geometry'}->{'location'}->{'lat'};
		$long = $json->{'results'}[0]->{'geometry'}->{'location'}->{'lng'};
		return $lat.','.$long;
	}
	
    public function staffprofileAction()
    {
        $this->view->pageTitle = "Profile";
		$this->view->id = 0;
		if($this->getRequest()->getParam('id')) {
			$this->view->id = $this->getRequest()->getParam('id');
		}
		
		$dbStaff = new Application_Model_StaffHelper();
		
        if ($this->getRequest()->isPost()) {
			if($this->getRequest()->getPost('btnupload')) {
				if(!empty($_FILES['file_name']['tmp_name'])) {
					$filename = $_FILES['file_name']['tmp_name'];
				} else {
					$filename = 'na';
				}
				$result = $dbStaff->uploadStaffFile($this->getRequest()->getPost(),$filename);
				$this->view->id = $result;
			}
			
			if($this->getRequest()->getPost('btnsave')) {
				$result = $dbStaff->saveStaffInfo($this->getRequest()->getPost());
				$this->view->id = $result;
			}
			$this->_redirect('/client/staff/staffprofile?id='.$this->view->id);
		}
		
		if($this->view->id > 0) {
			$this->view->profile = $dbStaff->fetchStaffById($this->view->id);
			if($this->view->profile == 0) {
				$this->view->id = 0;
			} else {
				$this->view->uploadTypes = $dbStaff->fetchStaffsUploadTypes($this->view->id);
				$this->view->staffData = $dbStaff->fetchStaffUploadsnInfo($this->view->id);
			}
		}
    }
	
	public function removeuploadAction() {
		$this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$dbStaff = new Application_Model_StaffHelper();
		$id = $this->getRequest()->getParam('id');
		$result = $dbStaff->removeStaffUpload($id);
		echo $result;
	}
	
	public function removeinfoAction() {
		$this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$dbStaff = new Application_Model_StaffHelper();
		$id = $this->getRequest()->getParam('id');
		$result = $dbStaff->removeStaffExtraInfo($id);
		echo $result;
	}
	
	public function sendmessageAction() {
		//$this->_helper->layout->setLayout('layout-blank');
		$_SESSION['s_auth']['user_email'] = 'anoop@otscom.net';
		$_SESSION['s_auth']['user_fname'] = 'Anoop';
		$_SESSION['s_auth']['user_lname'] = 'Krishan';
		$dbStaff = new Application_Model_StaffHelper();
		$id = $this->getRequest()->getParam('id');
		
		$rs = $dbStaff->getStaffPhoneEmail($id);
		$this->view->pageTitle = "Send Message : <a href='".WEB_SERVER_ROOT."client/staff/staffprofile?id=".$id."'>".$rs['f_name'].' '.$rs['l_name']."</a>";
		
		$this->view->toemail = $rs['user_email'];
		$this->view->tophone = $rs['user_phone'];	
		$arr = array();
		if(isset($_POST["btnemail"])) {
			$to = $this->getRequest()->getParam('txtto');
			$from = $this->getRequest()->getParam('txtfrom');
			$subject = $this->getRequest()->getParam('txtsubject');
			$body = $this->getRequest()->getParam('txtbody');
			$smtpconfig = array('auth' => 'login', 'username' => 'c3noreply@otscom.net', 'password' => 'Zx]9Yd7-=$8V', 'port' => 587);
			$smtptransport = new Zend_Mail_Transport_Smtp('mail.otscom.net', $smtpconfig);
			$mail = new Zend_Mail();
			$mail->setBodyHtml($body);
			//$mail->setFrom("it@simplyportals.com","Energy Experts");
			$mail->setFrom($from,"Energy Experts");
			$mail->addTo($to, '');
			$mail->setSubject($subject);
			$mail->send($smtptransport);
		} else if(isset($_POST["btnsms"])) {
			$to = $this->getRequest()->getParam('txttoph');
			$body = $this->getRequest()->getParam('txtbody');
			$postURL = 'https://twilio.simplyportals.ca/index.php?to='.urlencode($to).'&body='.urlencode($body);
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, $postURL);
			curl_setopt($ch,CURLOPT_HTTPHEADER, Array("Content-Type: text/plain; charset=utf-8")); 
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, 1); 
			curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($ch,CURLOPT_SSL_VERIFYHOST, 0);
			$result = curl_exec($ch);
			curl_close($ch);
			//print_r($result);die();
		}
		
		/* if ($this->getRequest()->isPost()) {
			if($this->getRequest()->getParam('btnemail')) {
				
				$to = $this->getRequest()->getParam('txtto');
				$from = $this->getRequest()->getParam('txtfrom');
				$subject = $this->getRequest()->getParam('txtsubject');
				$body = $this->getRequest()->getParam('txtbody');
				$smtpconfig = array('auth' => 'login', 'username' => 'error@simplyportals.com', 'password' => 'CVFov9HE', 'port' => 587);
				$smtptransport = new Zend_Mail_Transport_Smtp('mail.simplyportals.com', $smtpconfig);
				$mail = new Zend_Mail();
				$mail->setBodyHtml($body);
				//$mail->setFrom("it@simplyportals.com","Energy Experts");
				$mail->setFrom($from,"Energy Experts");
				$mail->addTo($to, '');
				$mail->setSubject($subject);
				$mail->send($smtptransport);
			}
			
			if($this->getRequest()->getParam('btnsms')) {
				
				$to = $this->getRequest()->getParam('txttoph');
				$body = $this->getRequest()->getParam('txtbody');
			}
		} */
	}
	
	public function dayscheduleAction() {
		$this->_helper->layout->setLayout('layout-schedule');
		$this->view->id = 0;
		$staff = '';
		if($this->getRequest()->getParam('id')) {
			$this->view->id = $this->getRequest()->getParam('id');
			$dbStaff = new Application_Model_StaffHelper();
			$rs = $dbStaff->fetchStaffById($this->view->id);
			$staff = $rs['f_name'].' '.$rs['l_name'];
			$this->view->daytypeList = $dbStaff->cmdGetStaffdaytypemasterlist();
			$dt = date('Y-m-d');
			$this->view->dt = $dt;
			$this->view->dty = strval(date('Y',strtotime($dt)));
			$this->view->dtm = strval(date('m',strtotime($dt)));
			$this->view->dtd = strval(date('d',strtotime($dt)));
			$this->view->instID = $this->view->id;
			$this->view->pageTitle = "Day Schedule : <a href='".WEB_SERVER_ROOT."client/staff/staffprofile?id=".$this->view->id."'>".$staff."</a>";
		} else {
			$this->view->pageTitle = 'Day Schedule';
		}
		
	}
	
	public function AddHours($initialDate,$additionsHours) {
		$newHours=$additionsHours+substr($initialDate,11,2);
		return substr($initialDate,0,10)." ".sprintf("%02u",$newHours).substr($initialDate,13);
	}
	
	public function calendareventsAction() {
        $this->_helper->layout()->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);
		$db = new Application_Model_StaffHelper();
		if ($_REQUEST['action'] == "getdayschedule") {
            //$dtfrom = date('Y-m-d', strtotime($_REQUEST['start'])).' 00:00:00';
            //$dtto = date('Y-m-d', strtotime($_REQUEST['end'])).' 23:59:59';
			$dtfrom = '2022-01-01 00:00:00';
			$dtto = '2022-04-01 23:59:59';
			$instId = $_REQUEST['id'];
            $rs = $db->cmdGetdayscheduleByStaffId($dtfrom,$dtto,$instId);
            $jsonschedule = array();
            for ($i = 0; $i < count($rs); $i++) {
                /* $rstag = $db->cmdGetAgentscheduletag($rs[$i]['schedule_id']);
                $strtaglist = '';
                for ($j = 0; $j < count($rstag); $j++) {
                    $strtaglist = $strtaglist.'<h6 style="display:inline-block;"><span class="tag label label-default"><span>'.$rstag[$j]['tag_detail'].'</span></span></h6>';
                } */
                $AppTime=date("g:i A",strtotime($rs[$i]['day_start']))." - ".date("g:i A",strtotime($this->AddHours($rs[$i]['day_start'],$rs[$i]['dayduration'])));
                $schedule = array(
                    'apptime' => $AppTime,
                    'id' => $rs[$i]['schedule_id'],
					'sid' => $rs[$i]['schedule_id'],
                    'title' => $rs[$i]['daytype_title'].' : '.$AppTime,
					'description' => $rs[$i]['daytype_title'].' : '.$AppTime,
                    'start' => $rs[$i]['day_start'],
                    'originalstart' => $rs[$i]['day_start'],
                    'end' => $rs[$i]['day_end'],
                    'originalend' => $rs[$i]['day_end'],
                    'comment' => $rs[$i]['day_comment'],
                    'resourceId' => $rs[$i]['installatorsID'],
                    'installatorsID' => $rs[$i]['installatorsID'],
                    'color' => $rs[$i]['bgcolor'],
                    'installername' => $rs[$i]['firstName'].' '.$rs[$i]['lastName'],
                    'installerinstid' => $rs[$i]['instID'],
                    //'taglist' => $strtaglist,
                    'allDay' => false
                );
                array_push($jsonschedule, $schedule);
            }
			/* $schedule = array('id' => $_REQUEST['instId'],'start' => $dtfrom,'end' => $dtto);
			$jsonschedule = array();
			array_push($jsonschedule, $schedule); */
            echo (json_encode($jsonschedule));
        }
		
		if ($_REQUEST['action'] == "addschedule") {
            $agentid = $_POST['agentid'];
            $daytypeid = $_POST['daytypeid'];
            $daystart = $_POST['daystart'];
            $dayend = $_POST['dayend'];
            $daycomment = '-na-';
            $createdby = $_SESSION['s_auth']['adminsID'];
            $currentstatus = "A";
            $date1 = new DateTime($daystart);
            $date2 = new DateTime($dayend);

            $diff = $date2->diff($date1);

            $hoursduration = $diff->h;
            $hoursduration = $hoursduration + ($diff->days*24);
            $strcheckdate = substr($daystart,0,10);
            $rs = $db->cmdCheckStaffdayscheduletypepresence($strcheckdate,$daytypeid,$agentid);
            for ($i = 0; $i < count($rs); $i++) {
                $icount = $rs[$i]['icount'];
            }

            if($icount == 0) {
                $arr = array();
                $arr['agentid'] = $agentid;
                $arr['daytypeid'] = $daytypeid;
                $arr['daystart'] = $daystart;
                $arr['dayend'] = $dayend;
                $arr['hoursduration'] = $hoursduration;
                $arr['actualduration'] = $hoursduration;
                $arr['daycomment'] = '-na-';
                $arr['createdby'] = $agentid;
                $arr['currentstatus'] = 'A';
                $result = $db->cmdAddStaffdayschedule($arr);
                echo 1;
            } else {
                echo -1;
            }
        }
		
        if ($_REQUEST['action'] == "removeschedule") {
            $scheduleid = $_POST['scheduleid'];
            $result = $db->cmdRemoveschedule($scheduleid);
            echo 1;
        }
	}
}