<?php
class Client_TicketsController extends Zend_Controller_Action {
	
    public function init() {
        session_start();
		$this->view->browserTitle = APPLICATION_TITLE;
		$this->view->layoutMode = "light";
		$this->_helper->layout->setLayout('layout-client');	
    }
    
    private function checkAuthentication() {
        if(!isset($_SESSION['s_auth_client']) || count($_SESSION['s_auth_client'])==0) {
            $this->_redirect(WEB_SERVER_ROOT);
        }
    }
    public function indexAction() {
        $this->checkAuthentication();
        $this->view->pageTitle = "Tickets";
		$dbTicket = new Application_Model_TicketHelper();
		$this->view->tickets = $dbTicket->getTicketsByRole();
    }
    
    public function ticketqueuesAction() {
        $this->checkAuthentication();
        $this->view->pageTitle = 'Ticket Queues';
        $clientID = $_SESSION['s_auth_client']['s_user']['client_id'];
        $dbTicket = new Application_Model_TicketHelper();
        $this->view->queues = $dbTicket->getQueues($clientID);
    }
	
    public function addqueueAction() {
        $this->checkAuthentication();
		$this->view->pageTitle = 'Add Queue';
		$dbTicket = new Application_Model_TicketHelper();
        if($this->getRequest()->isPost()) {
            $arr = array();
			$arr['id'] = $this->getRequest()->getPost('id');
            $arr['queue_title'] = $this->getRequest()->getPost('queue_title');
            $arr['clientID'] = $_SESSION['s_auth_client']['s_user']['client_id'];
            $arr['res_id'] = $this->getRequest()->getPost('res_id');
            $arr['escalation_threshold'] = $this->getRequest()->getPost('escalation_threshold');            
            $result = $dbTicket->saveQueue($arr);
            //$this->view->result = $result;
			$this->_redirect(WEB_SERVER_ROOT.'client/tickets/ticketqueues');
        }
		
		if($this->getRequest()->getParam('id')) {
			$this->view->queue = $dbTicket->getQueueByID($this->getRequest()->getParam('id'));
			$this->view->id = $this->getRequest()->getParam('id');
		} else {
			$this->view->id = 0;
		}
		$this->view->resolvers = $dbTicket->getResolvers($_SESSION['s_auth_client']['s_user']['client_id']);
    }
	
    public function changequeuestatusAction() {
        $this->checkAuthentication();
        $this->_helper->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
	    $resID = $this->getRequest()->getQuery('id');
	    $dbTicket = new Application_Model_TicketHelper();
	    $result = $dbTicket->changeQueueStatus($resID);
	    //echo json_encode($result);
		$this->_redirect(WEB_SERVER_ROOT.'client/tickets/ticketqueues');
    }
    /*** RESOLVERS ***/
    public function resolversAction() {
        $this->checkAuthentication();
        $this->view->pageTitle = 'Resolvers';
        $clientID = $_SESSION['s_auth_client']['s_user']['client_id'];
        $dbTicket = new Application_Model_TicketHelper();
        $this->view->resolvers = $dbTicket->getResolvers($clientID);
    }
    
    public function changeresolverstatusAction() {
        $this->checkAuthentication();
        $this->_helper->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
	    $resID = $this->getRequest()->getQuery('id');
	    $dbTicket = new Application_Model_TicketHelper();
	    $result = $dbTicket->changeResolverStatus($resID);
	    //echo json_encode($result);
		$this->_redirect(WEB_SERVER_ROOT.'client/tickets/resolvers');
    }
    
    public function addresolverAction() {
        $this->checkAuthentication();
		$this->view->pageTitle = 'Add Resolver';
		$dbTicket = new Application_Model_TicketHelper();
        if($this->getRequest()->isPost()) {
            $arr = array();
			$arr['id'] = $this->getRequest()->getPost('id');
            $arr['name'] = $this->getRequest()->getPost('txtName');
            $arr['email'] = $this->getRequest()->getPost('txtEmail');
            $arr['phone'] = $this->getRequest()->getPost('txtPhone');
            $arr['whatsapp'] = $this->getRequest()->getPost('txtWhatsApp');
            $arr['skype'] = $this->getRequest()->getPost('txtSkype');
            $arr['viber'] = $this->getRequest()->getPost('txtViber');
			$arr['clientID'] = $_SESSION['s_auth_client']['s_user']['client_id'];
            
            $result = $dbTicket->saveResolver($arr);
            //$this->view->result = $result;
			$this->_redirect(WEB_SERVER_ROOT.'client/tickets/resolvers');
        }
		
		if($this->getRequest()->getParam('id')) {
			$this->view->resolver = $dbTicket->getResolverByID($this->getRequest()->getParam('id'));
			$this->view->id = $this->getRequest()->getParam('id');
		} else {
			$this->view->id = 0;
		}
    }
    
    public function editresolverAction() {
        $this->checkAuthentication();
        $dbTicket = new Application_Model_TicketHelper();
        $arr = array();
        if($this->getRequest()->isPost()) {
            $arr['id'] = $this->getRequest()->getPost('hdnID');
            $arr['name'] = $this->getRequest()->getPost('txtName');
            $arr['email'] = $this->getRequest()->getPost('txtEmail');
            $arr['phone'] = $this->getRequest()->getPost('txtPhone');
            $arr['whatsapp'] = $this->getRequest()->getPost('txtWhatsApp');
            $arr['skype'] = $this->getRequest()->getPost('txtSkype');
            $arr['viber'] = $this->getRequest()->getPost('txtViber');
            
            $result = $dbTicket->saveResolver($arr);
            $this->view->result = $result;
        }
        $arr['id'] = $this->getRequest()->getQuery('resID');
        $resolver = $dbTicket->getResolverByID($arr['id']);
        $this->view->resolver = $resolver;
    }
    /*** RESOLVERS ***/
    
    /*** TICKET STATUSES ***/
    public function ticketstatusesAction() {
        $this->checkAuthentication();
		$this->view->pageTitle = "Ticket Status";
        $clientID = $_SESSION['s_auth_client']['s_user']['client_id'];
        $dbTicket = new Application_Model_TicketHelper();
        $this->view->tktStatuses = $dbTicket->getStatuses($clientID);
    }
    
    public function changestatusstatusAction() {
        $this->checkAuthentication();
        $this->_helper->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
	    $statusID = $this->getRequest()->getQuery('id');
	    $dbTicket = new Application_Model_TicketHelper();
	    $result = $dbTicket->changeStatusStatus($statusID);
	    //echo json_encode($result);
		$this->_redirect(WEB_SERVER_ROOT.'client/tickets/ticketstatuses');
    }
	
	public function manageticketstatusAction() {
		$this->checkAuthentication();
		$this->view->pageTitle = "Add/Edit Ticket Status";
        $clientID = $_SESSION['s_auth_client']['s_user']['client_id'];
		
		$dbTicket = new Application_Model_TicketHelper();
		$arr = array();
		if($this->getRequest()->getPost()) {
			$arr['id'] = $this->getRequest()->getPost('id');
			$arr['title'] = $this->getRequest()->getPost('txtStatusTitle');
			$arr['color'] = $this->getRequest()->getPost('txtColor');
			$arr['client'] = $clientID;
			$dbTicket->saveStatus($arr);
		} else {
			if($this->getRequest()->getQuery('id')!=0) {
				$this->view->ticketStatus = $dbTicket->getStatusByID($this->getRequest()->getQuery('id'));
			}
			$this->view->id = $this->getRequest()->getQuery('id');
		}
	}
    /*** TICKET STATUSES ***/

}