(function ($) {
  'use strict';
  $(function () {

    var data = {
      labels: ["10", "", "20", "", "30", "", "40", "", "50", "", "60"],
      datasets: [{
        label: '# of Votes',
        data: [10, 9, 8, 9, 12, 13, 14, 13, 12, 14, 13],
        backgroundColor: [
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
        ],
        borderColor: [
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
        ],
        borderWidth: 1,
        fill: false
      }]
    };

    var options = {
      scales: {
        yAxes: [{
          ticks: {
            display: false,
            min: 0
          },
          gridLines: {
            display: false
          },
          beginAtZero: true
        }],
        xAxes: [{
          barPercentage: 0.4,
          gridLines: {
            drawBorder: false,
          }
        }]
      },
      legend: {
        display: false
      },
      elements: {
        point: {
          radius: 0
        }
      }

    };

    if ($("#barchart").length) {
      var barChartCanvas = $("#barchart").get(0).getContext("2d");
      // This will get the first returned node in the jQuery collection.
      var barChart = new Chart(barChartCanvas, {
        type: 'bar',
        data: data,
        options: options
      });
    }
    // flot-bar chart
    $(function () {

      var data = [
        ["0", 5],
        ["1", 6],
        ["2", 7],
        ["3", 6],
        ["4", 7],
        ["5", 8],
        ["6", 7],
        ["7", 9],
      ];

      if ($("#column-chart").length) {
        $.plot("#column-chart", [data], {
          series: {
            bars: {
              show: true,
              barWidth: 0.2,
              align: "center",
              fillColor: '#ffffff',
            },
            color: '#ffffff',
            lines: {
              fill: true,
            }
          },
          xaxis: {
            mode: "categories",
            tickLength: 0,
            ticks: [],
          },
          yaxis: {
            ticks: [],
          },
          grid: {
            borderWidth: 0,
            labelMargin: 10,
            hoverable: true,
            clickable: true,
            mouseActiveRadius: 6,
          }

        });
      }
    });

    // doughnut chart starts here
    if ($("#doughnutChart1").length) {
      var ctx = document.getElementById('doughnutChart1').getContext("2d");

      var Blue = '#5e6eed';

      var red = '#ff5730';

      var green = '#00cff4';

      var trafficChartData = {
        datasets: [{
          data: [30, 30, 40],
          backgroundColor: [
            Blue,
            green,
            red
          ],
          hoverBackgroundColor: [
            Blue,
            green,
            red
          ],
          borderColor: [
            Blue,
            green,
            red
          ],
          legendColor: [
            Blue,
            green,
            red
          ]
        }],

        // These labels appear in the legend and in the tooltips when hovering different arcs
        labels: [
          'Organic search',
          'Refferral',
          'Social Media',
        ]
      };
      var trafficChartOptions = {
        responsive: true,
        animation: {
          animateScale: true,
          animateRotate: true
        },
        legend: false,
        legendCallback: function (chart) {
          var text = [];
          text.push('<ul>');
          for (var i = 0; i < trafficChartData.datasets[0].data.length; i++) {
            text.push('<li><span class="legend-dots" style="background:' +
              trafficChartData.datasets[0].legendColor[i] +
              '"></span>');
            if (trafficChartData.labels[i]) {
              text.push(trafficChartData.labels[i]);
            }
            // text.push('<span class="float-right">' + trafficChartData.datasets[0].data[i] + "%" + '</span>')
            text.push('</li>');
          }
          text.push('</ul>');
          return text.join('');
        }
      };
      var trafficChartCanvas = $("#doughnutChart1").get(0).getContext("2d");
      var trafficChart = new Chart(trafficChartCanvas, {
        type: 'doughnut',
        data: trafficChartData,
        options: trafficChartOptions
      });
      $("#doughnut-chart-legend").html(trafficChart.generateLegend());
    }
    if ($("#doughnutChart2").length) {
      var ctx = document.getElementById('doughnutChart2').getContext("2d");

      var blue1 = '#5e6eed';

      var red1 = '#ff0d59';

      var green1 = '#00d284';

      var trafficChartData = {
        datasets: [{
          data: [40, 20, 40],
          backgroundColor: [
            blue1,
            green1,
            red1
          ],
          hoverBackgroundColor: [
            blue1,
            green1,
            red1
          ],
          borderColor: [
            blue1,
            green1,
            red1
          ],
          legendColor: [
            blue1,
            green1,
            red1
          ]
        }],

        // These labels appear in the legend and in the tooltips when hovering different arcs
        labels: [
          'Page views',
          'New users',
          'Bounce rate',
        ]
      };
      var trafficChartOptions = {
        responsive: true,
        animation: {
          animateScale: true,
          animateRotate: true
        },
        legend: false,
        legendCallback: function (chart) {
          var text = [];
          text.push('<ul>');
          for (var i = 0; i < trafficChartData.datasets[0].data.length; i++) {
            text.push('<li><span class="legend-dots" style="background:' +
              trafficChartData.datasets[0].legendColor[i] +
              '"></span>');
            if (trafficChartData.labels[i]) {
              text.push(trafficChartData.labels[i]);
            }
            // text.push('<span class="float-right">' + trafficChartData.datasets[0].data[i] + "%" + '</span>')
            text.push('</li>');
          }
          text.push('</ul>');
          return text.join('');
        }
      };
      var trafficChartCanvas = $("#doughnutChart2").get(0).getContext("2d");
      var trafficChart = new Chart(trafficChartCanvas, {
        type: 'doughnut',
        data: trafficChartData,
        options: trafficChartOptions
      });
      $("#doughnut-chart-legend2").html(trafficChart.generateLegend());
    }
    if ($("#doughnutChart3").length) {
      var ctx = document.getElementById('doughnutChart3').getContext("2d");

      var blue2 = '#00cff4';

      var red2 = '#ff0d59';

      var green2 = '#00d284';

      var trafficChartData = {
        datasets: [{
          data: [40, 50, 10],
          backgroundColor: [
            blue2,
            green2,
            red2
          ],
          hoverBackgroundColor: [
            blue2,
            green2,
            red2
          ],
          borderColor: [
            blue2,
            green2,
            red2
          ],
          legendColor: [
            blue2,
            green2,
            red2
          ]
        }],

        // These labels appear in the legend and in the tooltips when hovering different arcs
        labels: [
          'Iphone',
          'Samsung',
          'Oneplus',
        ]
      };
      var trafficChartOptions = {
        responsive: true,
        animation: {
          animateScale: true,
          animateRotate: true
        },
        legend: false,
        legendCallback: function (chart) {
          var text = [];
          text.push('<ul>');
          for (var i = 0; i < trafficChartData.datasets[0].data.length; i++) {
            text.push('<li><span class="legend-dots" style="background:' +
              trafficChartData.datasets[0].legendColor[i] +
              '"></span>');
            if (trafficChartData.labels[i]) {
              text.push(trafficChartData.labels[i]);
            }
            text.push('</li>');
          }
          text.push('</ul>');
          return text.join('');
        }
      };
      var trafficChartCanvas = $("#doughnutChart3").get(0).getContext("2d");
      var trafficChart = new Chart(trafficChartCanvas, {
        type: 'doughnut',
        data: trafficChartData,
        options: trafficChartOptions
      });
      $("#doughnut-chart-legend3").html(trafficChart.generateLegend());
    }
  });

  // gradient line chart
  if ($("#linechart").length) {
    var chart = document.getElementById('linechart').getContext('2d'),
      gradient = chart.createLinearGradient(0, 0, 0, 150);

    gradient.addColorStop(0, 'rgba(0, 210, 132, 0.78)');
    gradient.addColorStop(0.5, 'rgba(255, 255, 255, 0.2)');
    gradient.addColorStop(1, 'rgba(255, 255, 255, 0.1)');

    var data = {
      labels: ["", "jan", "", "feb", "", "mar", "", "apr", "", "may", "", "nov", ""],
      datasets: [{
        label: 'Custom Label Name',
        backgroundColor: gradient,
        pointBackgroundColor: 'white',
        borderWidth: 1,
        borderColor: '#00d284',
        data: [15, 16, 15, 14, 13, 12, 13, 14, 16, 15, 16, 17, 18],
      }]
    };

    var options = {
      responsive: true,
      maintainAspectRatio: true,
      animation: {
        easing: 'easeInOutQuad',
        duration: 520
      },
      scales: {
        xAxes: [{
          gridLines: {
            color: 'rgba(0, 210, 132, 0.41)',
            lineWidth: 1,
            drawBorder: false,
          }
        }],
        yAxes: [{
          gridLines: {
            display: false,
            drawBorder: false
          },
          ticks: {
            display: false,
            beginAtZero: true
          }
        }]
      },
      elements: {
        line: {
          tension: 0.4
        }
      },
      legend: {
        display: false
      },
      point: {
        backgroundColor: 'white'
      },
    };

    var chartInstance = new Chart(chart, {
      type: 'line',
      data: data,
      options: options
    });
  }

  // linechart dark

  if ($("#linechartDark").length) {
    var chart = document.getElementById('linechartDark').getContext('2d'),
      gradient = chart.createLinearGradient(0, 0, 0, 150);

    gradient.addColorStop(0, 'rgba(0, 210, 132, 0.78)');
    gradient.addColorStop(0.5, 'rgba(255, 255, 255, 0.2)');
    gradient.addColorStop(1, 'rgba(255, 255, 255, 0.01)');

    var data = {
      labels: ["", "jan", "", "feb", "", "mar", "", "apr", "", "may", "", "nov", ""],
      datasets: [{
        label: 'Custom Label Name',
        backgroundColor: gradient,
        pointBackgroundColor: 'white',
        borderWidth: 1,
        borderColor: '#00d284',
        data: [15, 16, 15, 14, 13, 12, 13, 14, 16, 15, 16, 17, 18],
      }]
    };

    var options = {
      responsive: true,
      maintainAspectRatio: true,
      animation: {
        easing: 'easeInOutQuad',
        duration: 520
      },
      scales: {
        xAxes: [{
          gridLines: {
            color: 'rgba(0, 210, 132, 0.41)',
            lineWidth: 1,
            drawBorder: false,
          }
        }],
        yAxes: [{
          gridLines: {
            display: false,
            drawBorder: false
          },
          ticks: {
            display: false,
            beginAtZero: true
          }
        }]
      },
      elements: {
        line: {
          tension: 0.4
        }
      },
      legend: {
        display: false
      },
      point: {
        backgroundColor: 'white'
      },
    };

    var chartInstance = new Chart(chart, {
      type: 'line',
      data: data,
      options: options
    });
  }


    if ($("#deseaseReport").length) {
      var ctx = document.getElementById('deseaseReport').getContext("2d");

      var deseaseReportData = {
        datasets: [{
          data: [10, 30, 40, 20],
          backgroundColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          hoverBackgroundColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          borderColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          legendColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ]
        }],

        // These labels appear in the legend and in the tooltips when hovering different arcs
        labels: [
          'Pneumonia',
          'Daibetis',
          'Colds',
          'Flue'
        ]
      };
      var deseaseReportOptions = {
        responsive: true,
        animation: {
          animateScale: true,
          animateRotate: true
        },
        legend: false,
        legendCallback: function (chart) {
          var text = [];
          text.push('<ul class="m-auto pl-0 w-100 d-flex justify-content-between">');
          for (var i = 0; i < deseaseReportData.datasets[0].data.length; i++) {
            text.push('<li><div><span class="legend-dots" style="background:' +
            deseaseReportData.datasets[0].legendColor[i] +
              '"></span>');
            if (deseaseReportData.labels[i]) {
              text.push(deseaseReportData.labels[i]);
            }
            text.push('</div></li>');
          }
          text.push('</ul>');
          return text.join('');
        }
      };
      var deseaseReportCanvas = $("#deseaseReport").get(0).getContext("2d");
      var deseaseReport = new Chart(deseaseReportCanvas, {
        type: 'doughnut',
        data: deseaseReportData,
        options: deseaseReportOptions
      });
      $("#deseaseReport-legend3").html(deseaseReport.generateLegend());
    }
    if ($("#employeeDepartment").length) {
      var ctx = document.getElementById('employeeDepartment').getContext("2d");

      var employeeDepartmentData = {
        datasets: [{
          data: [10, 30, 40, 20],
          backgroundColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          hoverBackgroundColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          borderColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ],
          legendColor: [
            "#00cff4",
            "#5e6eed",
            "#ff0d59",
            "#00d284"
          ]
        }],

        // These labels appear in the legend and in the tooltips when hovering different arcs
        labels: [
          'Developer',
          'Designer',
          'Sales',
          'Tester'
        ]
      };
      var employeeDepartmentOptions = {
        responsive: true,
        animation: {
          animateScale: true,
          animateRotate: true
        },
        legend: false,
        legendCallback: function (chart) {
          var text = [];
          text.push('<ul class="m-auto pl-0 w-100">');
          for (var i = 0; i < employeeDepartmentData.datasets[0].data.length; i++) {
            text.push('<li class="mb-1"><div><span class="legend-dots" style="background:' +
            employeeDepartmentData.datasets[0].legendColor[i] +
              '"></span>');
            if (employeeDepartmentData.labels[i]) {
              text.push(employeeDepartmentData.labels[i]);
            }
            text.push('</div></li>');
          }
          text.push('</ul>');
          return text.join('');
        }
      };
      var employeeDepartmentCanvas = $("#employeeDepartment").get(0).getContext("2d");
      var employeeDepartment = new Chart(employeeDepartmentCanvas, {
        type: 'doughnut',
        data: employeeDepartmentData,
        options: employeeDepartmentOptions
      });
      $("#employeeDepartment-legend3").html(employeeDepartment.generateLegend());
    }
    var totalSalaryData = {
      labels: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
      datasets: [{
        label: '# of Votes',
        data: [76, 65, 24, 65, 89, 122, 146],
        backgroundColor: [
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
        ],
        borderColor: [
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
          '#5e6eed',
        ],
        borderWidth: 1,
        fill: false
      }]
    };

    var totalSalaryOptions = {
      scales: {
        yAxes: [{
          ticks: {
            display: false,
            min: 0
          },
          gridLines: {
            display: false
          },
          beginAtZero: true
        }],
        xAxes: [{
          barPercentage: 0.3,
          gridLines: {
            drawBorder: false,
            color: "rgba(169, 169, 169, .32)" 
          }
        }]
      },
      legend: {
        display: false
      },
      elements: {
        point: {
          radius: 0
        }
      }

    };

    if ($("#totalSalary").length) {
      var totalSalaryCanvas = $("#totalSalary").get(0).getContext("2d");
      // This will get the first returned node in the jQuery collection.
      var totalSalary = new Chart(totalSalaryCanvas, {
        type: 'bar',
        data: totalSalaryData,
        options: totalSalaryOptions
      });
    }
    $(".close-hr-banner").on("click", function() {
      $('.hr-banner').hide();
    });
})(jQuery);
